<script lang="ts">
	import { ProgressRadial } from '@skeletonlabs/skeleton';
	import PokemonList from '$lib/components/pokemon/PokemonList.svelte';
	import { createQuery } from '@tanstack/svelte-query';
	import { api } from '$lib/api';
	import { getToastStore } from '@skeletonlabs/skeleton';
	import type { CreatePokemonRequest } from '$lib';

	const toastStore = getToastStore();

	let busy = false;
	let limit = 10;

	$: pokemon = createQuery({
		queryKey: ['pokemon', limit],
		queryFn: () => api().loadPokemonData(limit)
	});

	async function onPokemonSelect({ detail }: { detail: string }) {
		busy = true;
		try {
			const pokemonResponse = await api().getPokemonByName(detail);
			const { name, types, moves, sprites } = pokemonResponse;
			const pokemon: CreatePokemonRequest = {
				name,
				front_sprite_url: sprites.front_default,
				back_sprite_url: sprites.back_default,
				front_shiny_sprite_url: sprites.front_shiny,
				back_shiny_sprite_url: sprites.back_shiny,
				types: types.map(({ type }) => ({ name: type.name })),
				moves: moves.map(({ move }) => ({ name: move.name }))
			};
			console.info(pokemon);
			// TODO: Save to DB
		} catch (e) {
			console.error(e);
			toastStore.trigger({
				message: 'Unable to save'
			});
		} finally {
			busy = false;
		}
	}
</script>

{#if $pokemon.isLoading}
	<section class="flex flex-col items-center justify-center mt-10 gap-5">
		<ProgressRadial width="w-20" />
		<span class="font-bold text-2xl"> Loading Pokemon... </span>
	</section>
{:else if $pokemon.isError}
	<p>Error loading pokemon data: {$pokemon.error.message}</p>
{:else}
	<section class="mt-10 mx-5">
		<PokemonList {busy} pokemonList={$pokemon.data} on:pokemonSelected={onPokemonSelect} />
	</section>
{/if}
